# gcp Namespace Reference

GChemPaint specific C++ classes. More...

## Classes

struct | IconDesc
class | Application
| GChemPaint application base class. More...
class | Arrow
class | Atom
struct | BondCrossing
class | Bond
class | DocPropDlg
class | Document
class | Electron
class | FragmentAtom
class | FragmentResidue
class | Fragment
| Atoms groups. More...
class | HPosDlg
class | Mesomer
class | MesomeryArrow
class | Mesomery
class | Molecule
| GChemPaint molecule class. More...
class | NewFileDlg
class | Operation
class | AddOperation
class | DeleteOperation
class | ModifyOperation
class | Plugin
| Class for GChemPaint plugins. More...
class | PrefsDlg
| GChemPaint preferences dialog class. More...
class | Reactant
| Class for reactants and products of a chemical reaction. More...
class | ReactionArrow
class | ReactionOperator
| Class for '+' signs in chemical reaction equations. More...
class | ReactionPropDlg
| reaction properties dialog box class. More...
class | ReactionProp
class | ReactionStep
| the list of reactants before or after a reaction arrow. More...
class | Reaction
| Chemical reaction class. More...
class | Residue
| a GChemPaint specific Residue class. More...
class | StringDlg
class | Target
class | TextObject
class | Text
class | Theme
| themes class. More...
class | ThemeManager
| themes engine class. More...
class | Tool
class | Tools
class | View
class | WidgetData
class | Window
class | ZoomDlg

## Enumerations

enum | ArrowTypes { SimpleArrow, ReversibleArrow, FullReversibleArrow }
enum | HPos { LEFT_HPOS, RIGHT_HPOS, TOP_HPOS, BOTTOM_HPOS, AUTO_HPOS }
enum | BondType
enum | OperationType { GCP_ADD_OPERATION, GCP_DELETE_OPERATION, GCP_MODIFY_OPERATION }
enum | { REACTION_PROP_UNKNOWN, REACTION_PROP_CATALYST, REACTION_PROP_REACTANT, REACTION_PROP_PRODUCT, REACTION_PROP_SOLVENT, REACTION_PROP_MAX_MOL, REACTION_PROP_TEMPERATURE = REACTION_PROP_MAX_MOL, REACTION_PROP_PRESSURE, REACTION_PROP_TIME, REACTION_PROP_ENTHALPY, REACTION_PROP_MAX }
enum | { GCP_CLIPBOARD_NATIVE, GCP_CLIPBOARD_SVG, GCP_CLIPBOARD_SVG_XML, GCP_CLIPBOARD_EPS, GCP_CLIPBOARD_PNG, GCP_CLIPBOARD_JPEG, GCP_CLIPBOARD_BMP, GCP_CLIPBOARD_NO_TEXT, GCP_CLIPBOARD_UTF8_STRING = GCP_CLIPBOARD_NO_TEXT, GCP_CLIPBOARD_STRING, GCP_CLIPBOARD_ALL }
enum | ThemeType { DEFAULT_THEME_TYPE, LOCAL_THEME_TYPE, GLOBAL_THEME_TYPE, FILE_THEME_TYPE }
enum | SelectionState { SelStateUnselected = 0, SelStateSelected, SelStateUpdating, SelStateErasing }

## Functions

bool | on_event (GnomeCanvasItem *item, GdkEvent *event, GtkWidget *widget)
void | on_receive (GtkClipboard *clipboard, GtkSelectionData *selection_data, View *pView)

## Variables

gcu::SignalId | OnChangedSignal
gcu::SignalId | OnDeleteSignal
gcu::SignalId | OnThemeChangedSignal
gcu::TypeId | ElectronType
std::set< Plugin * > | Plugins
char const * | ReactionPropRoles []
const gchar * | Color
const gchar * | DeleteColor
const gchar * | AddColor
const gchar * | SelectColor
unsigned | MaxStackSize
bool | MergeAtoms
int | CompressionLevel
bool | TearableMendeleiev
int | ClipboardFormats
ThemeManager | TheThemeManager

## Detailed Description

GChemPaint specific C++ classes.

The namespace used for the C++ classes used by GChemPaint.

file

## Enumeration Type Documentation

anonymous enum

This enumerates the known roles of objects attached to a reaction arrow

Enumerator:

  REACTION_PROP_UNKNOWN | Unkonw role.
  REACTION_PROP_CATALYST | Catalyst
  REACTION_PROP_REACTANT | Reactant
  REACTION_PROP_PRODUCT | Product
  REACTION_PROP_SOLVENT | Solvent
  REACTION_PROP_MAX_MOL | Values allowed for molecules are lower than this one
  REACTION_PROP_TEMPERATURE | Temperature
  REACTION_PROP_PRESSURE | Pressure
  REACTION_PROP_TIME | Reaction time.
  REACTION_PROP_ENTHALPY | Reaction enthalpy
  REACTION_PROP_MAX | The first value greater than all knwo values.

Definition at line 41 of file reaction-prop.h.

anonymous enum

Clipboard formats identifiers

Enumerator:

  GCP_CLIPBOARD_NATIVE | GChemPaint native xml data
  GCP_CLIPBOARD_SVG | SVG image format.
  GCP_CLIPBOARD_SVG_XML | SVG+XML image format (actually equivalent to GCP_CLIPBOARD_SVG).
  GCP_CLIPBOARD_EPS | Encapsulated Postscript (not really used).
  GCP_CLIPBOARD_PNG | PNG image format.
  GCP_CLIPBOARD_JPEG | JPEG image format.
  GCP_CLIPBOARD_BMP | BMP image format.
  GCP_CLIPBOARD_NO_TEXT | Number of supported formats, excluding string formats which are used only for debugging purposes.
  GCP_CLIPBOARD_UTF8_STRING | UTF8 string.
  GCP_CLIPBOARD_STRING | ASCII string.
  GCP_CLIPBOARD_ALL | Number of supported formats, including string formats

Definition at line 74 of file settings.h.

enum gcp::ArrowTypes

Enumeration of the known reaction arrow types.

Enumerator:

  SimpleArrow | Simple reaction arrow.
  ReversibleArrow | Double reaction arrow for reversible reactions with half heads.
  FullReversibleArrow | Double reaction arrow for reversible reactions with full heads.

Definition at line 36 of file arrow.h.

enum gcp::BondType

gcp/bond.h The bond types recognized in GChemPaint. Possible values are:

- NormalBondType: normal bonds,
- UpBondType: wedge bond,
- DownBondType: hash bond,
- ForeBondType: large bond,
- UndeterminedBondType: squiggled bond.

Definition at line 42 of file gcp/bond.h.

enum gcp::HPos

Represents the various possiblepositions for implicit hydrogen atoms bonded to non metals.

Enumerator:

  LEFT_HPOS | Hydrogen atoms at left.
  RIGHT_HPOS | Hydrogen atoms at right.
  TOP_HPOS | Hydrogen atoms at top.
  BOTTOM_HPOS | Hydrogen atoms at bottom.
  AUTO_HPOS | Automatic position.

Definition at line 85 of file gcp/atom.h.

enum gcp::OperationType

gcp/operation.h Enumeration of the different operation types See gcp::Document::GetNewOeration() for its use.

Enumerator:

  GCP_ADD_OPERATION | Object addition operation, see the AddOperation class.
  GCP_DELETE_OPERATION | Object deletion operation, see the DeleteOperation class.
  GCP_MODIFY_OPERATION | Object modification operation, see the ModifyOperation class.

Definition at line 41 of file operation.h.

enum gcp::SelectionState

Enumeration of the selection states used in GChemPaint in the gcu::Object::SetSelected method.

Enumerator:

  SelStateUnselected | Unselected object.
  SelStateSelected | Unselected object.
  SelStateUpdating | Edited or new object.
  SelStateErasing | The object is marked for deletion.

Definition at line 48 of file widgetdata.h.

enum gcp::ThemeType

gcp/theme.h Enumerates the various storage classes for themes.

Enumerator:

  DEFAULT_THEME_TYPE | The default theme.
  LOCAL_THEME_TYPE | A user defined theme which might be modified on the fly.
  GLOBAL_THEME_TYPE | A global theme which can't be edited.
  FILE_THEME_TYPE | A theme loaded from a data file. Such themes can be modified.

Definition at line 50 of file theme.h.

## Function Documentation

bool gcp::on_event | ( | GnomeCanvasItem * | item,
|  | GdkEvent * | event,
|  | GtkWidget * | widget |
| ) |  |  |

Parameters:

  | item | the item for which the event occured.
  | event | the current GdkEvent.
  | widget | the canvas owning the item.

A callback for events occuring in the canvas. Calls View::OnEvent() for the view owning widget.

void gcp::on_receive | ( | GtkClipboard * | clipboard,
|  | GtkSelectionData * | selection_data,
|  | View * | pView |
| ) |  |  |

Parameters:

  | clipboard | a GtkClipboard.
  | selection_data | the data to paste.
  | pView | the view of the active document.

A callback to use for receiving data from a clipboard. Calls View::OnReceive().

## Variable Documentation

const gchar* gcp::AddColor

The color used for new objects.

int gcp::ClipboardFormats

Number of really used clipboard formats when copying should be either GCP_CLIPBOARD_NO_TEXT or GCP_CLIPBOARD_ALL

const gchar* gcp::Color

The color used for normal drawing.

int gcp::CompressionLevel

XML file compression level.

const gchar* gcp::DeleteColor

The color used for objects that are to be deleted.

gcu::TypeId gcp::ElectronType

The dynamic TypeId for electrons.

unsigned gcp::MaxStackSize

The stack size for undo/redo operations. Default is no limit.

bool gcp::MergeAtoms

Whether to use existing atoms or create new one at the same place when adding bonds.

gcu::SignalId gcp::OnChangedSignal

Signal emitted when an object has been modified. See gcu::Object::EmitSignal for more information.

gcu::SignalId gcp::OnDeleteSignal

Signal emitted when an object has been deleted. See gcu::Object::EmitSignal for more information.

gcu::SignalId gcp::OnThemeChangedSignal

Signal emitted when the theme has changed. This signal is called by the theme for all its documents.

gcp::Plugins

The set of registered plugins.

char const* gcp::ReactionPropRoles[]

The names associated with the various roles knwon for objects attached to reaction arrows. These names are used for serialization.

const gchar* gcp::SelectColor

The color used for selected objects.

bool gcp::TearableMendeleiev

Whether the mendeleiv table widget might be detached from the tool box or not.

ThemeManager gcp::TheThemeManager

The themes manager unique instance.